/* *******************************************************************
 Website:  http://wch.cn
 Email:    tech@wch.cn
 Author:   W.ch 2011.8
 CH463 ӿӳ
**********************************************************************
 CH4632߽ӿڣֻҪ2I/OţI2C/IICʱ
 Ϊ˽Լʱ䣬ʵSCL/SDA֮ʱ
 ϣSCL·ãôֻҪSDA仯SCLͿκ;
 ϣSCLSDA·ãôؼȷSDAֻSCLΪ͵ƽڼ䷢仯SCLSDAʺΪʹ
 1SCLţֱ
 2SDAţʱ
 SCLΪ͵ƽôֱ
 SCLΪߵƽôȽSCL͵ƽٽSDASCLָΪߵƽ
*************************************************************************** */
#include "reg51.H" 
#include "INTRINS.H" 
#include "CH463IF.H"              // ޸ĸļӦӲ/Ƭͺŵ
  

void CH463_I2c_Start( void )                     // ʼ
{                                                
    CH463_SDA_SET;                               // ʼź
    CH463_SDA_D_OUT;                             // SDAΪ 
    CH463_SCL_SET;                               
    CH463_SCL_D_OUT;                             // SCLΪ 
    DELAY_0_1US;                                 
    CH463_SDA_CLR;                               //ʼź
    DELAY_0_1US;                                 
    CH463_SCL_CLR;                               //ǯסI2Cߣ׼ͻ 
}                                                
                                                 
void CH463_I2c_Stop( void )                      // 
{
    CH463_SDA_CLR;
    DELAY_0_1US;
    CH463_SCL_SET;
    DELAY_0_1US;
    CH463_SDA_SET;                               // I2C߽ź
    DELAY_0_1US;
}

void CH463_I2c_WrByte( unsigned char dat )       // дһֽ
{
    unsigned char i;
    for( i = 0; i != 8; i++ )                    // 8λ
    {
        if( dat&0x80 ) { CH463_SDA_SET; }
        else { CH463_SDA_CLR; }
        DELAY_0_1US;
        CH463_SCL_SET;
        dat<<=1;
        DELAY_0_1US;                             // ѡʱ
        CH463_SCL_CLR;
    }
    CH463_SDA_SET;
    DELAY_0_1US;
    CH463_SCL_SET;                               // Ӧ
    DELAY_0_1US;
    CH463_SCL_CLR;
}

unsigned char CH463_I2c_RdByte( void )          // һֽ
{
    unsigned char dat,i;
    CH463_SDA_SET;
    CH463_SDA_D_IN;                              // SDAΪ뷽 
    dat=0;
    for( i = 0; i != 8; i++ )                    // 8λ
    {
        DELAY_0_1US;                             // ѡʱ
        CH463_SCL_SET;
        DELAY_0_1US;                            // ѡʱ
        dat<<=1;
        if(CH463_SDA_IN) dat++;                 // 1λ
        CH463_SCL_CLR;
    }
    CH463_SDA_SET;
    DELAY_0_1US;
    CH463_SCL_SET;                             // ЧӦ
    DELAY_0_1US;
    CH463_SCL_CLR;
    return(dat);
}


void CH463WriteRegister( unsigned char regaddr,unsigned char mdata )    // д
{
    unsigned short tmp;

	tmp = (unsigned short)(regaddr << 9)| mdata;

	CH463_I2c_Start();                             // 
    CH463_I2c_WrByte( ( unsigned char )( tmp>>8 ) );
    CH463_I2c_WrByte( ( unsigned char ) tmp );    // 
    CH463_I2c_Stop();    //   
}

unsigned char CH463ReadByteRegister( unsigned char regaddr)    // ȡ
{
    unsigned char din;
    din = regaddr<<1 | 0x01;    

	CH463_I2c_Start();                           // 
    CH463_I2c_WrByte( din );                     // ֵΪ0x4D
    din=CH463_I2c_RdByte();                      // ȡ
    CH463_I2c_Stop();                            // 
    return( din );
}














